## beegfs 8.1.0~20250810022543.7%2Bbookworm

=== Makefile ===
# all variables used by package builds must be exported.
export BEEGFS_DEBUG
export USER_CXXFLAGS
export USER_LDFLAGS
export BEEGFS_DEBUG_RDMA
export BEEGFS_DEBUG_IP

export KDIR
export KSRCDIR

BEEGFS_THIRDPARTY_OPTIONAL =
export BEEGFS_THIRDPARTY_OPTIONAL

WITHOUT_COMM_DEBUG = true

# if version is not set, derive from current git.
# debian epoch for unversioned builds (usually dev builds) is 19 because it was 18 previously.
# versioned builds (usually from tags) are set to epoch 20, allowing upgrades from all previous versions.
ifndef BEEGFS_VERSION
  BEEGFS_VERSION := $(shell git describe --tags --match '*.*' --abbrev=10)
  BEEGFS_EPOCH := 19
else
  BEEGFS_EPOCH := 20
endif

# underscores are not allowed in version strings, because they are not valid semver
ifneq (,$(findstring _,$(BEEGFS_VERSION)))
  $(error Underscores not allowed in versions. BEEGFS_VERSION is $(BEEGFS_VERSION))
endif

# dashes in semver for pre-releases should be converted to tildes for package managers in the
# distributions we support
BEEGFS_VERSION_RPM := $(subst -,~,$(BEEGFS_VERSION))
BEEGFS_VERSION_DEB := $(BEEGFS_EPOCH):$(subst -,~,$(BEEGFS_VERSION))
export BEEGFS_VERSION

ifneq ($(NVFS_INCLUDE_PATH),)
BEEGFS_NVFS=1
endif
export BEEGFS_NVFS

PREFIX ?= /opt/beegfs
DESTDIR ?=

DAEMONS := meta storage mon
UTILS := fsck event_listener $(if $(WITHOUT_COMM_DEBUG),,comm_debug)

# exclude components with no runnable tests from `test'.
DO_NOT_TEST := thirdparty event_listener

ALL_COMPONENTS := thirdparty common $(DAEMONS) $(UTILS)
TIDY_COMPONENTS := $(filter-out thirdparty event_listener, $(ALL_COMPONENTS))

all: daemons utils client

.PHONY: daemons
daemons: $(patsubst %,%-all,$(DAEMONS))
	@

.PHONY: utils
utils: $(patsubst %,%-all,$(UTILS))
	@

.PHONY: $(patsubst %,%-all,$(DAEMONS) $(UTILS))
$(patsubst %,%-all,$(DAEMONS) $(UTILS)): common-all
	$(MAKE) -C $(subst -all,,$@)/build all

.PHONY: common-all common
common-all: thirdparty
	$(MAKE) -C common/build all

.PHONY: thirdparty
thirdparty:
	$(MAKE) -C thirdparty/build all $(BEEGFS_THIRDPARTY_OPTIONAL)

.PHONY: client
client:
	$(MAKE) -C client_module/build

.PHONY: tidy
tidy: $(addsuffix -tidy,$(TIDY_COMPONENTS))
	@

define tidy_component
.PHONY: $1-tidy
$1-tidy:
	+$(MAKE) -C $1/build tidy
endef

$(foreach C,$(TIDY_COMPONENTS),$(eval $(call tidy_component,$(C))))

_tested_components := $(filter-out $(DO_NOT_TEST),$(ALL_COMPONENTS))

.PHONY: test
test: $(patsubst %,%-test,$(_tested_components))
	@

define test_component
.PHONY: $1-test
$1-test: $1-all
	cd $1/build && ./test-runner --compiler
endef

$(foreach C,$(_tested_components),$(eval $(call test_component,$(C))))

.PHONY: install
install: daemons-install utils-install common-install client-install event_listener-install
	@

define install_component
.PHONY: $1-install
$1-install: $1-all
	install -t $(DESTDIR)/$(PREFIX)/$2 -D \
		$1/build/beegfs-$$(or $$(install_name),$1)
endef

comm_debug-install: install_name=comm-debug

$(foreach D,$(DAEMONS),$(eval $(call install_component,$D,sbin)))
$(foreach U,$(filter-out event_listener,$(UTILS)),$(eval $(call install_component,$U,sbin)))

.PHONY: daemons-install
daemons-install: $(patsubst %,%-install,$(DAEMONS))
	@

.PHONY: utils-install
utils-install: $(patsubst %,%-install,$(UTILS))
	@

.PHONY: common-install
common-install: common-all
	install -t $(DESTDIR)/$(PREFIX)/lib -D \
		common/build/libbeegfs_ib.so

.PHONY: client-install
client-install: client
	install -t $(DESTDIR)/$(PREFIX)/lib/modules/$(KVER)/kernel/beegfs -D \
		client_module/build/beegfs.ko

## Overriding previous generic rule due to non-matching executable name
.PHONY: event_listener-intsall
event_listener-install: event_listener-all
	install -t $(DESTDIR)/$(PREFIX)/sbin -D \
		event_listener/build/beegfs-event-listener

.PHONY: clean
clean: $(patsubst %,%-clean,$(ALL_COMPONENTS)) client-clean
	@

.PHONY: $(patsubst %,%-clean,$(ALL_COMPONENTS))
$(patsubst %,%-clean,$(ALL_COMPONENTS)):
	$(MAKE) -C $(subst -clean,,$@)/build clean

.PHONY: client-clean
client-clean:
	$(MAKE) -C client_module/build clean

# use DEBUILD_OPTS to pass more options to debuild, eg
#   DEBUILD_OPTS='-j32 --prepend-path=/usr/lib/ccache'
# for greater concurrency during build and ccache support
.PHONY: package-deb
package-deb: clean
	[ '$(PACKAGE_DIR)' ] || { echo need a PACKAGE_DIR >&2; false; }
	! [ -d '$(PACKAGE_DIR)' ] || { echo choose a new directory for PACKAGE_DIR, please >&2; false; }
	mkdir -p '$(PACKAGE_DIR)'
	cd '$(PACKAGE_DIR)' && \
		dpkg-source -I '-I$(PACKAGE_DIR)' -z1 -b '$(dir $(realpath $(firstword $(MAKEFILE_LIST))))' && \
		rm -rf build && \
		dpkg-source -x *.dsc build && \
		( \
			cd build; \
			sed -i -e 's/beegfs (.*)/beegfs ($(BEEGFS_VERSION_DEB))/' debian/changelog; \
			sed -i -e 's/@DATE/$(shell date -R)/' debian/changelog; \
			debuild -eBEEGFS_\* $(DEBUILD_OPTS) -us -uc -b 2>&1 | grep -Ev "dir-or-file-in-opt" \
		) && \
		rm -rf build *.dsc *.tar.gz \
		# Replace tilde in package filename with hypens.
		# Github release action and api substitutes tilde (~) with dot (.) in file names when uploaded to Github packages.
		find -type f -name "*~*.deb" -exec bash -c 'mv "$$1" "$${1//\~/-}"' _ {} \;

# use RPMBUILD_OPTS to pass more options to rpmuild, eg
#   RPMBUILD_OPTS='-D "MAKE_CONCURRENCY 32"'
# for greater concurrency during build
.PHONY: package-rpm
package-rpm: clean
	[ '$(PACKAGE_DIR)' ] || { echo need a PACKAGE_DIR >&2; false; }
	! [ -d '$(PACKAGE_DIR)' ] || { echo choose a new directory for PACKAGE_DIR, please >&2; false; }
	mkdir -p $(PACKAGE_DIR)/SOURCES
	tar --exclude $(PACKAGE_DIR) --exclude .git --exclude .ccache \
		-cf $(PACKAGE_DIR)/SOURCES/beegfs-$(BEEGFS_VERSION_RPM).tar .
	rpmbuild --clean -bb beegfs.spec \
		--define '_topdir $(abspath $(PACKAGE_DIR))' \
		--define 'EPOCH $(BEEGFS_EPOCH)' \
		--define 'BEEGFS_VERSION $(BEEGFS_VERSION_RPM)' \
		$(RPMBUILD_OPTS) \
	# Replace tilde in package filename with hypens.
	# Github release action and api substitutes tilde (~) with dot (.) in file names when uploaded to Github packages.
	find $(PACKAGE_DIR)/RPMS -type f -name "*~*.rpm" -exec bash -c 'mv "$$1" "$${1//\~/-}"' _ {} \;

=== build/Makefile ===
##### BASE MAKEFILE
#
# This makefile is intended to be a basis on which new makefiles are written.
# It is divided into five parts:
#  * help text generation
#  * path for subproject locations and thirparty include/library paths
#  * default values for tools (like CXX) and compiler/linker flags
#  * description of known libraries that may be used in the build
#  * functions that define build artifacts
#
# library handling will be described in detail later.
#
# we have three functions that defined build artifacts:
#  * build-executable
#  * build-static-library
#  * build-dynamic-library
#
# they all have the same, basic signature:
#    (name: string, sources: list<string>, usedLibraries: list<string>)
#
# $name determines the name given to the output file (for executables) or the library name given
# to the output library (for libraries).
#
# $sources must be a list of source files (allowed types are .cpp and .c), relative to the directory
# of the Makefile you are writing (see example below).
#
# $usedLibraries is a (possibly empty) list of libraries as defined in the KNOWN LIBRARIES section
# below. they will be automatically added to compiler and linker invocations as needed.
#
# EXAMPLE:
#
# imagine you have a project with a directory structure like this:
#  - /build
#    - Makefile
#  - /source
#    - /lib
#      - ...
#    - /exe
#      - ...
#
# you want your Makefile to build a shared library from /source/lib and an executable from
# /source/exe. the you could write your Makefile like this:
#
# include ,../../build/Makefile
#
# # will generate a libFancy.so in /build, uses libz
# $(call build-static-library,\
#     Fancy,\
#     $(shell find ../source/lib -iname '*.cpp'),\
#     z)
#
# # this registers libFancy as a shared library. see details below (KNOWN LIBRARIES).
# $(call define-dep-lib, Fancy, -I ../source/lib/include, -L . -l Fancy)
#
# # will generate an executable file Run in /build, uses libFancy
# $(call build-executable,\
#    Run,\
#    $(shell find ../source/exe -iname '*.cpp'),\
#    Fancy)
#
# # a dependency must be added between Run and Fancy, to ensure that Fancy is built first.
# Run: | libFancy.so

override V := $(if $V,,@)

all:

define HELP_ARGS_GENERIC
	@echo  '  BEEGFS_DEBUG=1             Enables debug information and symbols'
	@echo  '  BEEGFS_DEBUG_OPT=1         Enables internal debug code, but compiled'
	@echo  '                             with optimizations'
	@echo  '  BEEGFS_DEBUG_IP=1          Enables low-level debug of network sendto'
	@echo  '                             and recvfrom'
	@echo  '  CXX=<compiler>             Specifies a c++ compiler'
	@echo  '  DISTCC=distcc              Enables the usage of distcc'
	@echo  '  V=1                        Print command lines of tool invocations'
	@echo  '  BEEGFS_COMMON_PATH=<path>  Path to the common directory'
	@echo  '  BEEGFS_THIRDPARTY_PATH=<path>'
	@echo  '                             Path to the thirdparty directory'
	@echo  '  BEEGFS_USE_PCH=1           Enables use of precompiled headers'
endef
define HELP_TARGETS_GENERIC
	@echo '  all (default)     build only'
	@echo '  clean             delete compiled files'
	@echo '  help              print this help message'
endef

help:
	@echo 'Optional arguments:'
	$(HELP_ARGS_GENERIC)
	$(HELP_ARGS_SPECIFIC)
	@echo
	@echo 'Targets:'
	$(HELP_TARGETS_GENERIC)
	$(HELP_TARGETS_SPECIFIC)

root_dir := $(realpath $(dir $(lastword $(MAKEFILE_LIST)))/..)
build_dir := $(realpath $(dir $(firstword $(MAKEFILE_LIST))))

BEEGFS_COMMON_PATH             ?= $(root_dir)/common
BEEGFS_COMMON_PCH_H            ?= $(BEEGFS_COMMON_PATH)/source/common/pch.h
BEEGFS_THIRDPARTY_PATH         ?= $(root_dir)/thirdparty
BEEGFS_COMM_DEBUG_PATH         ?= $(root_dir)/comm_debug
BEEGFS_FSCK_PATH               ?= $(root_dir)/fsck
BEEGFS_EVENT_LISTENER_PATH     ?= $(root_dir)/event_listener
BEEGFS_DEVEL_INCLUDE_PATH      ?= $(root_dir)/client_devel/include
BEEGFS_CLIENT_PATH             ?= $(root_dir)/client_module/include

BOOST_INC_PATH    ?= $(BEEGFS_THIRDPARTY_PATH)/source/boost
NU_INC_PATH       ?= $(BEEGFS_THIRDPARTY_PATH)/source/nu/include

GTEST_INC_PATH    ?= $(BEEGFS_THIRDPARTY_PATH)/source/gtest/googletest/include
GTEST_LIB_PATH    ?= $(BEEGFS_THIRDPARTY_PATH)/build

ifneq ($(target_arch),)
   STRIP := $(target_arch)-strip
   AR := $(target_arch)-ar
   CC := $(target_arch)-gcc
   CXX := $(target_arch)-g++
endif

SHELL := /bin/bash
STRIP ?= strip
CXX   ?= g++
AR    ?= ar
CLANG_TIDY ?= clang-tidy

# if -T is supported by ar, use it. thin archives are quicker to create and maintain.
ifeq ($(shell ar -TM 2>&1 <<<""),)
AR += -T
endif

CXXFLAGS = \
   -std=c++17 -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64 \
   -isystem $(BOOST_INC_PATH) -isystem $(NU_INC_PATH) \
   -pthread \
   -fno-strict-aliasing -fmessage-length=0 \
   -Wall -Wextra -Wunused-variable -Woverloaded-virtual -Wno-unused-parameter -Wuninitialized \
      -Wno-missing-field-initializers \
      -Winvalid-pch \
   -ggdb3 \
   $(USER_CXXFLAGS)
CXXFLAGS_RELEASE = -O3 -Wuninitialized
CXXFLAGS_DEBUG = -O1 -D_FORTIFY_SOURCE=2 \
   -DBEEGFS_DEBUG -DDEBUG_READWRITE -DDEBUG_MUTEX_LOCKING -DDEBUG_REFCOUNT \
   -DDEBUG_BACKTRACE  -DLOG_DEBUG_MESSAGES
CXXFLAGS_COVERAGE = --coverage -O1 -fno-inline

LDFLAGS = -std=c++1y \
   -rdynamic \
   -pthread -lrt \
   -Wl,-rpath,'$$ORIGIN/../lib' \
   $(USER_LDFLAGS)
LDFLAGS_COVERAGE = --coverage

ifneq ($(BEEGFS_DEBUG),)
CXXFLAGS += $(CXXFLAGS_DEBUG)
else ifneq ($(BEEGFS_COVERAGE),)
CXXFLAGS += $(CXXFLAGS_COVERAGE)
LDFLAGS += $(LDFLAGS_COVERAGE)
else
CXXFLAGS += $(CXXFLAGS_RELEASE)
endif


CXXFLAGS += -DBEEGFS_VERSION="\"$(BEEGFS_VERSION)\""

ifeq ($(BEEGFS_NVFS),1)
CXXFLAGS += -DBEEGFS_NVFS
endif

ifeq ($(BEEGFS_DEBUG_RDMA),1)
CXXFLAGS += -DBEEGFS_DEBUG_RDMA
endif

ifneq ($(BEEGFS_DEBUG_IP),)
CXXFLAGS += -DBEEGFS_DEBUG_IP
endif

###### KNOWN LIBRARIES
#
# this is our local registry of known libraries, both our own and thirdparty libraries.
#
# currently supports building with our own libraries common and client-devel.
# thirdparty packages supported are:
#  * dl (from system)
#
# to define new libraries, add appriopriate calls to define-dep-lib in this section.
# the signature of define-dep-lib is:
#    (name: string, CXXFLAGS: string, libraryPath: string[, LDFLAGS: string])
#
# $name is used to identify the library within this registry, and is otherwise unused.
#
# $CXXFLAGS will be added to the set of CXXFLAGS used when compiling files from projects that use
# this library (see example at the beginning of this file for reference).
#
# $libraryPath is the path (absolute or relative) to the library. glob patterns are allowed, and in
# fact required if you want to link a dynamic library.
#
# $LDFLAGS will be added to the set of LDFLAGS used when linking shared libraries or executables
# that use this library. if the library you want to link is static, LDFLAGS need not be set - the
# library will be added to the list of archives.
#
#
# to define libraries that are taken from the system, use define-dep-lib-system. it will use its
# arguments to ask pkgconfig for the correct compiler and linker flags. then signature of
# define-dep-lib-system is:
#    (name: string, pkgconfigID: string)
#
# $name is used only to identify the library.
#
# $pkgconfigID is the identifier pkgconfig will be asked about.
define resolve-dep-cflags
$(if $(filter undefined,$(origin _DEP_LIB_CXX[$(strip $1)])),\
   $(error I have no CXXFLAGS for $1!),\
   $(_DEP_LIB_CXX[$(strip $1)]))
endef
define resolve-dep-ldflags
$(if $(filter undefined,$(origin _DEP_LIB_LD[$(strip $1)])),\
   $(error I have no LDFLAGS for $1!),\
   $(_DEP_LIB_LD[$(strip $1)]))
endef
define resolve-dep-deps
$(if $(filter undefined,$(origin _DEP_LIB_DEPS[$(strip $1)])),\
   $(error I have no library dependencies for $1!),\
   $(_DEP_LIB_DEPS[$(strip $1)]))
endef
define define-dep-lib
$(strip
   $(eval _DEP_LIB_CXX[$(strip $1)] = $(strip $2))
   $(eval _DEP_LIB_LD[$(strip $1)] = $(strip $(or $4, $3)))
   $(eval _DEP_LIB_DEPS[$(strip $1)] = $(strip $3))
   $(eval $(strip $3): ))
endef
define define-dep-lib-system
$(strip
   $(if $(shell pkg-config --exists $2 || echo fail),
      $(error Could not find library $2 in system!))
   $(call define-dep-lib,
      $1,
      $(shell pkg-config --cflags $2),
      $(shell pkg-config --libs $2)))
endef

# don't bother to search the system for libraries if we only run `make clean'
# this also has the nice side effect that libraries needn't be present in the system
# when `make clean' is run - if we override dependency resolution to not do anything.
ifeq ($(strip $(MAKECMDGOALS)),clean)
   resolve-dep-cflags :=
   resolve-dep-ldflags :=
   resolve-dep-deps :=
else
   $(call define-dep-lib, common,\
      -I $(BEEGFS_COMMON_PATH)/source \
      -I $(BEEGFS_CLIENT_PATH), \
      -ldl $(BEEGFS_COMMON_PATH)/build/libbeegfs-common.a)

   $(call define-dep-lib, client-devel,\
      -I $(BEEGFS_DEVEL_INCLUDE_PATH),)

   $(call define-dep-lib, dl, , , -ldl)

   $(call define-dep-lib, rdma, , -lrdmacm -libverbs)

   $(call define-dep-lib, gtest,\
      -isystem $(GTEST_INC_PATH)/include,\
      $(GTEST_LIB_PATH)/libgtest.a)

   $(call define-dep-lib, cassandra, -I$(BEEGFS_THIRDPARTY_PATH)/source/datastax)

   $(call define-dep-lib-system, curl, libcurl)  
   $(call define-dep-lib-system, z, zlib)

   $(call define-dep-lib, blkid, , , -lblkid)
   $(call define-dep-lib, uuid, , , -luuid)
   $(call define-dep-lib-system, nl3-route, libnl-route-3.0)
endif


clean:
	@$(RM) -rf $(if $V,,-v) $(CLEANUP_FILES)


NONDEP_MAKEFILES = $(filter-out %.d,$(MAKEFILE_LIST))

%.autogen.h:
	@# Generate a proxy-header for precompilation.
	@true > $@  # truncate file
	@echo '/* Autogenerated precompiled header (PCH)' >> $@
	@echo ' * For each set of compiler options we need to compile ' >> $@
	@echo ' * a PCH separately. To realize that, we create ' >> $@
	@echo ' * proxy PCHs like this file and compile these. */' >> $@
	@echo '#include "$(BEEGFS_COMMON_PCH_H)"' >> $@

%.h.gch: %.h
	@echo "[CXX]   $@"
	$V$(CXX) $(CXXFLAGS) -c $< -E -MMD -MP -MF$<.d -MT$@ -o/dev/null
	$V$(DISTCC) $(CXX) $(CXXFLAGS) -o$@ -c $(realpath $<)

%.cpp.o: %.cpp $(NONDEP_MAKEFILES)
	@echo "[CXX]   $<"
	$V$(DISTCC) $(CXX) $(CXXFLAGS) -MMD -MF$<.d -MT$<.o -MP -o $<.o -c $(realpath $<)

%.c.o: %.c $(NONDEP_MAKEFILES)
	@echo "[CXX]   $<"
	$V$(DISTCC) $(CXX) $(CXXFLAGS) -MMD -MF$<.d -MT$<.o -MP -o$<.o -c $(realpath $<)

# first partial list: checks we want to exclude on a general basis right now
# second list: very minor problems we don't want to be bugged about yet, but want to fix over time
# third list: definite errors, fix as soon as possible
define -clang_tidy_checks
-clang-analyzer-alpha.deadcode.UnreachableCode
-fuchsia-default-arguments
-fuchsia-overloaded-operator
-google-build-using-namespace
-google-readability-braces-around-statements
-google-readability-casting
-google-readability-namespace-comments
-hicpp-braces-around-statements
-llvm-header-guard
-llvm-include-order
-llvm-namespace-comment
-readability-braces-around-statements
-readability-implicit-bool-conversion

-android-cloexec-accept
-android-cloexec-creat
-android-cloexec-dup
-android-cloexec-epoll-create
-android-cloexec-fopen
-android-cloexec-open
-boost-use-to-string
-bugprone-branch-clone
-bugprone-exception-escape
-bugprone-narrowing-conversions
-bugprone-sizeof-expression
-cert-oop54-cpp
-clang-analyzer-core.CallAndMessage
-clang-analyzer-core.uninitialized.Assign
-clang-analyzer-cplusplus.NewDeleteLeaks
-clang-analyzer-deadcode.DeadStores
-clang-analyzer-optin.cplusplus.UninitializedObject
-clang-diagnostic-deprecated-copy
-cppcoreguidelines-avoid-c-arrays
-cppcoreguidelines-avoid-goto
-cppcoreguidelines-avoid-magic-numbers
-cppcoreguidelines-init-variables
-cppcoreguidelines-interfaces-global-init
-cppcoreguidelines-macro-usage
-cppcoreguidelines-narrowing-conversions
-cppcoreguidelines-non-private-member-variables-in-classes

=== client_devel/CMakeLists.txt ===
install(
	FILES "include/beegfs/beegfs.h" "include/beegfs/beegfs_ioctl.h" "include/beegfs/beegfs_ioctl_functions.h"
	DESTINATION "usr/include/beegfs"
	COMPONENT "client-devel"
)

install(
	FILES "build/dist/usr/share/doc/beegfs-client-devel/examples/createFileWithStripePattern.cpp"
	DESTINATION "usr/share/doc/beegfs/examples/createFileWithStripePattern"
	COMPONENT "client-devel"
)

=== client_module/CMakeLists.txt ===
if(NOT BEEGFS_SKIP_CLIENT)
	include(ExternalProject)

	ExternalProject_Add(
		client-module
		BUILD_IN_SOURCE ON
		URL "${CMAKE_CURRENT_SOURCE_DIR}"
		CONFIGURE_COMMAND ""
		BUILD_COMMAND make -C build -j $(nproc) "KDIR=${BEEGFS_KERNELDIR}" "OFED_INCLUDE_PATH=${BEEGFS_OFEDDIR}"
		INSTALL_COMMAND ""
	)
endif()

configure_file(
	"${CMAKE_CURRENT_SOURCE_DIR}/build/dkms.conf.client"
	"${CMAKE_CURRENT_BINARY_DIR}/dkms.conf.client"
)

configure_file(
	"${CMAKE_CURRENT_SOURCE_DIR}/build/dkms.conf.compat"
	"${CMAKE_CURRENT_BINARY_DIR}/dkms.conf.compat"
)

configure_file(

	"${CMAKE_CURRENT_SOURCE_DIR}/build/postinst.in"
	"${CMAKE_CURRENT_BINARY_DIR}/postinst"
)

configure_file(
	"${CMAKE_CURRENT_SOURCE_DIR}/build/prerm.in"
	"${CMAKE_CURRENT_BINARY_DIR}/prerm"
)

install(
	DIRECTORY ""
	DESTINATION "usr/src/beegfs-${BEEGFS_VERSION}"
	COMPONENT "client"
	USE_SOURCE_PERMISSIONS
	PATTERN "CMakeLists.txt" EXCLUDE
	PATTERN "dkms.conf.*" EXCLUDE
)

install(
	FILES "${CMAKE_CURRENT_BINARY_DIR}/dkms.conf.client"
	DESTINATION "usr/src/beegfs-${BEEGFS_VERSION}"
	RENAME "dkms.conf"
	COMPONENT "client"
)

install(
	FILES "build/dist/etc/beegfs-client.conf"
	DESTINATION "etc/beegfs"
	COMPONENT "client"
)

install(
	DIRECTORY ""
	DESTINATION "usr/src/beegfs-compat-${BEEGFS_VERSION}"
	COMPONENT "client-compat"
	USE_SOURCE_PERMISSIONS
	PATTERN "CMakeLists.txt" EXCLUDE
	PATTERN "dkms.conf.*" EXCLUDE
)

install(
	FILES "${CMAKE_CURRENT_BINARY_DIR}/dkms.conf.compat"
	DESTINATION "usr/src/beegfs-compat-${BEEGFS_VERSION}"
	RENAME "dkms.conf"
	COMPONENT "client-compat"
)

# Debian package settings
set(CPACK_DEBIAN_CLIENT_PACKAGE_DEPENDS "dkms" PARENT_SCOPE)

set(
	CPACK_DEBIAN_CLIENT_PACKAGE_CONTROL_EXTRA
	"${CMAKE_CURRENT_BINARY_DIR}/prerm;${CMAKE_CURRENT_BINARY_DIR}/postinst;${CMAKE_CURRENT_BINARY_DIR}/dkms.conf.client"
	PARENT_SCOPE
)

# currently no dkms in compat package
# set(
# 	CPACK_DEBIAN_CLIENT-COMPAT_PACKAGE_CONTROL_EXTRA
# 	"${CMAKE_CURRENT_BINARY_DIR}/dkms.conf.compat"
# 	PARENT_SCOPE
# )

# RPM package settings
set(CPACK_RPM_CLIENT_PACKAGE_REQUIRES "dkms" PARENT_SCOPE)

set(
	CPACK_RPM_PRE_UNINSTALL_SCRIPT_FILE
	"${CMAKE_CURRENT_BINARY_DIR}/prerm"
	PARENT_SCOPE
)

set(
	CPACK_RPM_POST_INSTALL_SCRIPT_FILE
	"${CMAKE_CURRENT_BINARY_DIR}/postinst"
	PARENT_SCOPE
)

=== common/CMakeLists.txt ===

include(FindPkgConfig)
if(NOT PKG_CONFIG_FOUND)
	message(FATAL_ERROR "pkg-config not found!" )
endif()

pkg_check_modules(NL3ROUTE REQUIRED IMPORTED_TARGET libnl-route-3.0)

include_directories(
	source
)

link_directories(
	${NL3ROUTE_LIBRARY_DIRS}
)

add_library(
	beegfs-common STATIC
	./source/common/Assert.cpp
	./source/common/toolkit/StorageTk.h
	./source/common/toolkit/RandomReentrant.h
	./source/common/toolkit/FsckTk.cpp
	./source/common/toolkit/HashTk.h
	./source/common/toolkit/UnitTk.h
	./source/common/toolkit/PreallocatedFile.h
	./source/common/toolkit/StringTk.h
	./source/common/toolkit/Time.h
	./source/common/toolkit/DisposalCleaner.h
	./source/common/toolkit/MessagingTk.cpp
	./source/common/toolkit/StringTk.cpp
	./source/common/toolkit/FileDescriptor.h
	./source/common/toolkit/EntryIdTk.h
	./source/common/toolkit/ObjectReferencer.h
	./source/common/toolkit/NamedException.h
	./source/common/toolkit/MapTk.cpp
	./source/common/toolkit/MapTk.h
	./source/common/toolkit/TimeAbs.h
	./source/common/toolkit/BitStore.h
	./source/common/toolkit/MetaStorageTk.h
	./source/common/toolkit/MetadataTk.cpp
	./source/common/toolkit/SessionTk.h
	./source/common/toolkit/BuildTypeTk.h
	./source/common/toolkit/ZipIterator.h
	./source/common/toolkit/HighResolutionStats.h
	./source/common/toolkit/NodesTk.h
	./source/common/toolkit/serialization/Serialization.h
	./source/common/toolkit/serialization/Byteswap.h
	./source/common/toolkit/serialization/SerializeStr.cpp
	./source/common/toolkit/OfflineWaitTimeoutTk.h
	./source/common/toolkit/AcknowledgmentStore.cpp
	./source/common/toolkit/SocketTk.h
	./source/common/toolkit/HashTk.cpp
	./source/common/toolkit/AtomicObjectReferencer.h
	./source/common/toolkit/poll/PollList.cpp
	./source/common/toolkit/poll/PollList.h
	./source/common/toolkit/poll/Pollable.h
	./source/common/toolkit/AcknowledgmentStore.h
	./source/common/toolkit/DisposalCleaner.cpp
	./source/common/toolkit/Time.cpp
	./source/common/toolkit/MinMaxStore.h
	./source/common/toolkit/NodesTk.cpp
	./source/common/toolkit/FsckTk.h
	./source/common/toolkit/UiTk.cpp
	./source/common/toolkit/MessagingTkArgs.h
	./source/common/toolkit/StorageTk.cpp
	./source/common/toolkit/MathTk.h
	./source/common/toolkit/MessagingTk.h
	./source/common/toolkit/TempFileTk.h
	./source/common/toolkit/FDHandle.h
	./source/common/toolkit/ListTk.h
	./source/common/toolkit/LockFD.cpp
	./source/common/toolkit/SocketTk.cpp
	./source/common/toolkit/SynchronizedCounter.h
	./source/common/toolkit/TimeTk.h
	./source/common/toolkit/NetFilter.h
	./source/common/toolkit/Pipe.h
	./source/common/toolkit/UnitTk.cpp
	./source/common/toolkit/BitStore.cpp
	./source/common/toolkit/TimeFine.h
	./source/common/toolkit/EntryIdTk.cpp
	./source/common/toolkit/DebugVariable.h
	./source/common/toolkit/Random.h
	./source/common/toolkit/UiTk.h
	./source/common/toolkit/LockFD.h
	./source/common/toolkit/TimeException.h
	./source/common/toolkit/TempFileTk.cpp
	./source/common/toolkit/MetadataTk.h
	./source/common/toolkit/BuildTypeTk.cpp
	./source/common/toolkit/hash_library/sha256.h
	./source/common/toolkit/hash_library/sha256.cpp
	./source/common/Common.h
	./source/common/benchmark/StorageBench.h
	./source/common/NumericID.h
	./source/common/net/sock/SocketDisconnectException.h
	./source/common/net/sock/Socket.cpp
	./source/common/net/sock/SocketTimeoutException.h
	./source/common/net/sock/RoutingTable.h
	./source/common/net/sock/RoutingTable.cpp
	./source/common/net/sock/RDMASocket.cpp
	./source/common/net/sock/StandardSocket.h
	./source/common/net/sock/SocketException.h
	./source/common/net/sock/Socket.h
	./source/common/net/sock/NetworkInterfaceCard.cpp
	./source/common/net/sock/NetworkInterfaceCard.h
	./source/common/net/sock/StandardSocket.cpp
	./source/common/net/sock/SocketInterruptedPollException.h
	./source/common/net/sock/SocketConnectException.h
	./source/common/net/sock/Channel.h
	./source/common/net/sock/PooledSocket.h
	./source/common/net/sock/RDMASocket.h
	./source/common/net/message/AbstractNetMessageFactory.cpp
	./source/common/net/message/SimpleStringMsg.h
	./source/common/net/message/mon/RequestStorageDataRespMsg.h
	./source/common/net/message/mon/RequestMetaDataMsg.h
	./source/common/net/message/mon/RequestStorageDataMsg.h
	./source/common/net/message/mon/RequestMetaDataRespMsg.h
	./source/common/net/message/SimpleIntStringMsg.h
	./source/common/net/message/AcknowledgeableMsg.h
	./source/common/net/message/NetMessage.h
	./source/common/net/message/control/AuthenticateChannelMsg.h
	./source/common/net/message/control/AckMsg.h
	./source/common/net/message/control/AuthenticateChannelMsgEx.h
	./source/common/net/message/control/AuthenticateChannelMsgEx.cpp
	./source/common/net/message/control/PeerInfoMsgEx.cpp
	./source/common/net/message/control/PeerInfoMsgEx.h
	./source/common/net/message/control/GenericResponseMsg.h
	./source/common/net/message/control/DummyMsg.h
	./source/common/net/message/control/SetChannelDirectMsg.h
	./source/common/net/message/control/PeerInfoMsg.h
	./source/common/net/message/NetMessageLogHelper.h
	./source/common/net/message/SimpleUInt16Msg.h
	./source/common/net/message/session/BumpFileVersionRespMsg.h
	./source/common/net/message/session/RefreshSessionMsg.h
	./source/common/net/message/session/opening/CloseChunkFileMsg.h
	./source/common/net/message/session/opening/OpenFileMsg.h
	./source/common/net/message/session/opening/CloseChunkFileRespMsg.h
	./source/common/net/message/session/opening/CloseFileRespMsg.h
	./source/common/net/message/session/opening/CloseFileMsg.h
	./source/common/net/message/session/opening/OpenFileRespMsg.h
	./source/common/net/message/session/AckNotifyRespMsg.h
	./source/common/net/message/session/AckNotifyMsg.h
	./source/common/net/message/session/rw/WriteLocalFileMsg.h
	./source/common/net/message/session/rw/WriteLocalFileRespMsg.h
	./source/common/net/message/session/rw/ReadLocalFileV2Msg.h
	./source/common/net/message/session/GetFileVersionMsg.h
	./source/common/net/message/session/RefreshSessionRespMsg.h
	./source/common/net/message/session/locking/FLockEntryRespMsg.h
	./source/common/net/message/session/locking/LockGrantedMsg.h
	./source/common/net/message/session/locking/FLockRangeRespMsg.h
	./source/common/net/message/session/locking/FLockRangeMsg.h
	./source/common/net/message/session/locking/FLockEntryMsg.h
	./source/common/net/message/session/locking/FLockAppendRespMsg.h
	./source/common/net/message/session/locking/FLockAppendMsg.h
	./source/common/net/message/session/FSyncLocalFileMsg.h
	./source/common/net/message/session/BumpFileVersionMsg.h
	./source/common/net/message/session/FSyncLocalFileRespMsg.h
	./source/common/net/message/session/GetFileVersionRespMsg.h
	./source/common/net/message/NetMessageTypes.h
	./source/common/net/message/SimpleMsg.h
	./source/common/net/message/SimpleIntMsg.h
	./source/common/net/message/nodes/GetMirrorBuddyGroupsRespMsg.h
	./source/common/net/message/nodes/RegisterTargetRespMsg.h
	./source/common/net/message/nodes/RemoveBuddyGroupRespMsg.h
	./source/common/net/message/nodes/GetTargetStatesMsg.h
	./source/common/net/message/nodes/GetTargetMappingsMsg.h
	./source/common/net/message/nodes/storagepools/RefreshStoragePoolsMsg.h
	./source/common/net/message/nodes/storagepools/RemoveStoragePoolMsg.h
	./source/common/net/message/nodes/storagepools/GetStoragePoolsRespMsg.h
	./source/common/net/message/nodes/storagepools/ModifyStoragePoolRespMsg.h
	./source/common/net/message/nodes/storagepools/GetStoragePoolsMsg.h
	./source/common/net/message/nodes/storagepools/ModifyStoragePoolMsg.h
	./source/common/net/message/nodes/storagepools/AddStoragePoolMsg.h
	./source/common/net/message/nodes/storagepools/RemoveStoragePoolRespMsg.h
	./source/common/net/message/nodes/storagepools/AddStoragePoolRespMsg.h
	./source/common/net/message/nodes/UnmapTargetRespMsg.h
	./source/common/net/message/nodes/GetMirrorBuddyGroupsMsg.h
	./source/common/net/message/nodes/GetTargetMappingsRespMsg.h
	./source/common/net/message/nodes/RemoveBuddyGroupMsg.h
	./source/common/net/message/nodes/GetTargetConsistencyStatesMsg.h
	./source/common/net/message/nodes/RegisterTargetMsg.h
	./source/common/net/message/nodes/PublishCapacitiesMsg.h
	./source/common/net/message/nodes/RefreshCapacityPoolsMsg.h
	./source/common/net/message/nodes/HeartbeatMsg.h
	./source/common/net/message/nodes/GetNodeCapacityPoolsMsg.h
	./source/common/net/message/nodes/UnmapTargetMsg.h
	./source/common/net/message/nodes/StorageBenchControlMsgResp.h
	./source/common/net/message/nodes/GetStatesAndBuddyGroupsMsg.h
	./source/common/net/message/nodes/HeartbeatRequestMsg.h
	./source/common/net/message/nodes/GetTargetConsistencyStatesRespMsg.h
	./source/common/net/message/nodes/SetTargetConsistencyStatesRespMsg.h
	./source/common/net/message/nodes/GenericDebugMsg.h
	./source/common/net/message/nodes/RegisterNodeMsg.h
	./source/common/net/message/nodes/RemoveNodeMsg.h
	./source/common/net/message/nodes/GetStatesAndBuddyGroupsRespMsg.h
	./source/common/net/message/nodes/SetTargetConsistencyStatesMsg.h
	./source/common/net/message/nodes/GenericDebugRespMsg.h
	./source/common/net/message/nodes/SetMirrorBuddyGroupRespMsg.h
	./source/common/net/message/nodes/GetClientStatsMsg.h
	./source/common/net/message/nodes/GetClientStatsRespMsg.h
	./source/common/net/message/nodes/GetNodeCapacityPoolsRespMsg.h
	./source/common/net/message/nodes/MapTargetsRespMsg.h
	./source/common/net/message/nodes/RefreshTargetStatesMsg.h
	./source/common/net/message/nodes/ChangeTargetConsistencyStatesRespMsg.h
	./source/common/net/message/nodes/MapTargetsMsg.h
	./source/common/net/message/nodes/StorageBenchControlMsg.h
	./source/common/net/message/nodes/RemoveNodeRespMsg.h
	./source/common/net/message/nodes/SetMirrorBuddyGroupMsg.h
	./source/common/net/message/nodes/GetNodesMsg.h
	./source/common/net/message/nodes/RegisterNodeRespMsg.h
	./source/common/net/message/nodes/GetTargetStatesRespMsg.h
	./source/common/net/message/nodes/GetNodesRespMsg.h
	./source/common/net/message/nodes/ChangeTargetConsistencyStatesMsg.h
	./source/common/net/message/AbstractNetMessageFactory.h
	./source/common/net/message/storage/TruncLocalFileMsg.h
	./source/common/net/message/storage/moving/MovingFileInsertRespMsg.h
	./source/common/net/message/storage/moving/RenameMsg.h
	./source/common/net/message/storage/moving/MovingDirInsertMsg.h
	./source/common/net/message/storage/moving/MovingFileInsertMsg.h
	./source/common/net/message/storage/moving/MovingDirInsertRespMsg.h
	./source/common/net/message/storage/moving/RenameRespMsg.h
	./source/common/net/message/storage/creating/RmDirMsg.h
	./source/common/net/message/storage/creating/MkFileWithPatternMsg.h
	./source/common/net/message/storage/creating/UnlinkFileRespMsg.h
	./source/common/net/message/storage/creating/MkFileWithPatternRespMsg.h
	./source/common/net/message/storage/creating/HardlinkRespMsg.h
	./source/common/net/message/storage/creating/UnlinkFileMsg.h
	./source/common/net/message/storage/creating/RmChunkPathsRespMsg.h
	./source/common/net/message/storage/creating/MkLocalDirRespMsg.h
	./source/common/net/message/storage/creating/MkFileMsg.h
	./source/common/net/message/storage/creating/MkFileRespMsg.h
	./source/common/net/message/storage/creating/HardlinkMsg.h
	./source/common/net/message/storage/creating/RmChunkPathsMsg.h
	./source/common/net/message/storage/creating/MkDirRespMsg.h
	./source/common/net/message/storage/creating/RmDirEntryMsg.h
	./source/common/net/message/storage/creating/MkLocalDirMsg.h
	./source/common/net/message/storage/creating/RmDirEntryRespMsg.h
	./source/common/net/message/storage/creating/RmDirRespMsg.h
	./source/common/net/message/storage/creating/UnlinkLocalFileMsg.h
	./source/common/net/message/storage/creating/RmLocalDirMsg.h
	./source/common/net/message/storage/creating/MkDirMsg.h
	./source/common/net/message/storage/creating/RmLocalDirRespMsg.h
	./source/common/net/message/storage/creating/UnlinkLocalFileRespMsg.h

=== mon/CMakeLists.txt ===
include_directories(
	source
)

add_library(
	mon STATIC
	./source/exception/CurlException.h
	./source/exception/DatabaseException.h
	./source/net/message/NetMessageFactory.h
	./source/net/message/NetMessageFactory.cpp
	./source/net/message/nodes/HeartbeatMsgEx.h
	./source/components/NodeListRequestor.cpp
	./source/components/StatsCollector.h
	./source/components/StatsCollector.cpp
	./source/components/NodeListRequestor.h
	./source/components/worker/GetNodesWork.cpp
	./source/components/worker/RequestMetaDataWork.cpp
	./source/components/worker/RequestStorageDataWork.cpp
	./source/components/worker/RequestStorageDataWork.h
	./source/components/worker/RequestMetaDataWork.h
	./source/components/worker/GetNodesWork.h
	./source/components/CleanUp.cpp
	./source/components/CleanUp.h
	./source/app/Config.h
	./source/app/App.h
	./source/app/Config.cpp
	./source/app/App.cpp
	./source/app/SignalHandler.cpp
	./source/app/SignalHandler.h
	./source/app/Main.cpp
	./source/misc/CurlWrapper.cpp
	./source/misc/InfluxDB.cpp
	./source/misc/CurlWrapper.h
	./source/misc/Cassandra.h
	./source/misc/InfluxDB.h
	./source/misc/Cassandra.cpp
	./source/misc/TSDatabase.h
	./source/nodes/NodeStoreMgmtEx.cpp
	./source/nodes/NodeStoreStorageEx.cpp
	./source/nodes/NodeStoreMetaEx.h
	./source/nodes/StorageNodeEx.h
	./source/nodes/NodeStoreMetaEx.cpp
	./source/nodes/MetaNodeEx.cpp
	./source/nodes/MgmtNodeEx.cpp
	./source/nodes/NodeStoreStorageEx.h
	./source/nodes/StorageNodeEx.cpp
	./source/nodes/MetaNodeEx.h
	./source/nodes/MgmtNodeEx.h
	./source/nodes/NodeStoreMgmtEx.h
)

target_include_directories(
	mon PRIVATE
	../thirdparty/source/datastax
)

target_link_libraries(
	mon
	beegfs-common
	pthread
	dl
	curl
)

add_executable(
	beegfs-mon
	source/app/Main.cpp
)

target_link_libraries(
	beegfs-mon
	mon
)

# if(NOT BEEGFS_SKIP_TESTS)
# 	add_executable(
# 		test-meta
# 		# no tests yet
# 	)
# 
# 	target_link_libraries(
# 		test-mon
# 		mon
# 		gtest
# 	)
# 
# 	# required for a test
# 	file(
# 		COPY ${CMAKE_CURRENT_SOURCE_DIR}/build/dist/etc/beegfs-mon.conf
# 		DESTINATION dist/etc/
# 	)
# 
# 	add_test(
# 		NAME test-mon
# 		COMMAND test-mon --compiler
# 	)
# endif()

install(
	TARGETS beegfs-mon
	DESTINATION "usr/sbin"
	COMPONENT "mon"
)

install(
	FILES "build/dist/usr/lib/systemd/system/beegfs-mon.service" "build/dist/usr/lib/systemd/system/beegfs-mon@.service"
	DESTINATION "${CMAKE_INSTALL_LIBDIR}/systemd/system"
	COMPONENT "mon"
)

install(
	FILES "build/dist/etc/beegfs-mon.conf"
	DESTINATION "etc/beegfs"
	COMPONENT "mon"
)

install(
	FILES "build/dist/etc/beegfs-mon.auth"
	DESTINATION "etc/beegfs"
	COMPONENT "mon"
)

=== storage/CMakeLists.txt ===
include_directories(
	source
)

add_library(
	storage STATIC
	./source/toolkit/QuotaTk.h
	./source/toolkit/StorageTkEx.h
	./source/toolkit/QuotaTk.cpp
	./source/net/message/mon/RequestStorageDataMsgEx.cpp
	./source/net/message/mon/RequestStorageDataMsgEx.h
	./source/net/message/control/AckMsgEx.h
	./source/net/message/control/SetChannelDirectMsgEx.cpp
	./source/net/message/control/AckMsgEx.cpp
	./source/net/message/control/SetChannelDirectMsgEx.h
	./source/net/message/NetMessageFactory.h
	./source/net/message/session/opening/CloseChunkFileMsgEx.h
	./source/net/message/session/opening/CloseChunkFileMsgEx.cpp
	./source/net/message/session/rw/WriteLocalFileMsgEx.h
	./source/net/message/session/rw/ReadLocalFileV2MsgEx.h
	./source/net/message/session/rw/ReadLocalFileV2MsgEx.cpp
	./source/net/message/session/rw/WriteLocalFileMsgEx.cpp
	./source/net/message/session/FSyncLocalFileMsgEx.h
	./source/net/message/session/FSyncLocalFileMsgEx.cpp
	./source/net/message/NetMessageFactory.cpp
	./source/net/message/nodes/SetTargetConsistencyStatesMsgEx.cpp
	./source/net/message/nodes/GetClientStatsMsgEx.h
	./source/net/message/nodes/MapTargetsMsgEx.cpp
	./source/net/message/nodes/RefreshTargetStatesMsgEx.cpp
	./source/net/message/nodes/storagepools/RefreshStoragePoolsMsgEx.h
	./source/net/message/nodes/storagepools/RefreshStoragePoolsMsgEx.cpp
	./source/net/message/nodes/HeartbeatMsgEx.cpp
	./source/net/message/nodes/RemoveBuddyGroupMsgEx.h
	./source/net/message/nodes/HeartbeatRequestMsgEx.h
	./source/net/message/nodes/GetClientStatsMsgEx.cpp
	./source/net/message/nodes/PublishCapacitiesMsgEx.h
	./source/net/message/nodes/GenericDebugMsgEx.cpp
	./source/net/message/nodes/GetTargetConsistencyStatesMsgEx.h
	./source/net/message/nodes/SetMirrorBuddyGroupMsgEx.h
	./source/net/message/nodes/PublishCapacitiesMsgEx.cpp
	./source/net/message/nodes/RemoveNodeMsgEx.cpp
	./source/net/message/nodes/StorageBenchControlMsgEx.cpp
	./source/net/message/nodes/SetTargetConsistencyStatesMsgEx.h
	./source/net/message/nodes/RemoveBuddyGroupMsgEx.cpp
	./source/net/message/nodes/StorageBenchControlMsgEx.h
	./source/net/message/nodes/HeartbeatRequestMsgEx.cpp
	./source/net/message/nodes/MapTargetsMsgEx.h
	./source/net/message/nodes/HeartbeatMsgEx.h
	./source/net/message/nodes/GenericDebugMsgEx.h
	./source/net/message/nodes/GetTargetConsistencyStatesMsgEx.cpp
	./source/net/message/nodes/RemoveNodeMsgEx.h
	./source/net/message/nodes/RefreshTargetStatesMsgEx.h
	./source/net/message/nodes/SetMirrorBuddyGroupMsgEx.cpp
	./source/net/message/storage/GetHighResStatsMsgEx.h
	./source/net/message/storage/creating/RmChunkPathsMsgEx.cpp
	./source/net/message/storage/creating/UnlinkLocalFileMsgEx.h
	./source/net/message/storage/creating/RmChunkPathsMsgEx.h
	./source/net/message/storage/creating/UnlinkLocalFileMsgEx.cpp
	./source/net/message/storage/chunkbalancing/CpChunkPathsMsgEx.cpp
	./source/net/message/storage/mirroring/StorageResyncStartedMsgEx.cpp
	./source/net/message/storage/mirroring/StorageResyncStartedMsgEx.h
	./source/net/message/storage/mirroring/GetStorageResyncStatsMsgEx.cpp
	./source/net/message/storage/mirroring/GetStorageResyncStatsMsgEx.h
	./source/net/message/storage/mirroring/ResyncLocalFileMsgEx.h
	./source/net/message/storage/mirroring/ResyncLocalFileMsgEx.cpp
	./source/net/message/storage/mirroring/SetLastBuddyCommOverrideMsgEx.cpp
	./source/net/message/storage/mirroring/SetLastBuddyCommOverrideMsgEx.h
	./source/net/message/storage/attribs/SetLocalAttrMsgEx.cpp
	./source/net/message/storage/attribs/SetLocalAttrMsgEx.h
	./source/net/message/storage/attribs/GetChunkFileAttribsMsgEx.h
	./source/net/message/storage/attribs/GetChunkFileAttribsMsgEx.cpp
	./source/net/message/storage/GetHighResStatsMsgEx.cpp
	./source/net/message/storage/TruncLocalFileMsgEx.cpp
	./source/net/message/storage/TruncLocalFileMsgEx.h
	./source/net/message/storage/StatStoragePathMsgEx.h
	./source/net/message/storage/StatStoragePathMsgEx.cpp
	./source/net/message/storage/listing/ListChunkDirIncrementalMsgEx.cpp
	./source/net/message/storage/listing/ListChunkDirIncrementalMsgEx.h
	./source/net/message/storage/quota/GetQuotaInfoMsgEx.h
	./source/net/message/storage/quota/SetExceededQuotaMsgEx.cpp
	./source/net/message/storage/quota/SetExceededQuotaMsgEx.h
	./source/net/message/storage/quota/GetQuotaInfoMsgEx.cpp
	./source/net/message/fsck/FetchFsckChunkListMsgEx.cpp
	./source/net/message/fsck/FetchFsckChunkListMsgEx.h
	./source/net/message/fsck/DeleteChunksMsgEx.cpp
	./source/net/message/fsck/MoveChunkFileMsgEx.h
	./source/net/message/fsck/MoveChunkFileMsgEx.cpp
	./source/net/message/fsck/DeleteChunksMsgEx.h
	./source/net/msghelpers/MsgHelperIO.h
	./source/components/chunkfetcher/ChunkFetcher.cpp
	./source/components/chunkfetcher/ChunkFetcherSlave.cpp
	./source/components/chunkfetcher/ChunkFetcher.h
	./source/components/chunkfetcher/ChunkFetcherSlave.h
	./source/components/DatagramListener.h
	./source/components/InternodeSyncer.h
	./source/components/StorageStatsCollector.h
	./source/components/InternodeSyncer.cpp
	./source/components/DatagramListener.cpp
	./source/components/worker/StorageBenchWork.cpp
	./source/components/worker/StorageBenchWork.h
	./source/components/benchmarker/StorageBenchOperator.cpp
	./source/components/benchmarker/StorageBenchOperator.h
	./source/components/benchmarker/StorageBenchSlave.cpp
	./source/components/benchmarker/StorageBenchSlave.h
	./source/components/streamlistenerv2/StorageStreamListenerV2.h
	./source/components/buddyresyncer/BuddyResyncer.cpp
	./source/components/buddyresyncer/BuddyResyncJob.h
	./source/components/buddyresyncer/BuddyResyncerGatherSlave.cpp
	./source/components/buddyresyncer/BuddyResyncerDirSyncSlave.cpp
	./source/components/buddyresyncer/SyncCandidate.h
	./source/components/buddyresyncer/BuddyResyncerGatherSlave.h
	./source/components/buddyresyncer/BuddyResyncerDirSyncSlave.h
	./source/components/buddyresyncer/BuddyResyncJob.cpp
	./source/components/buddyresyncer/BuddyResyncerFileSyncSlave.cpp
	./source/components/buddyresyncer/BuddyResyncerFileSyncSlave.h
	./source/components/buddyresyncer/BuddyResyncer.h
	./source/components/StorageStatsCollector.cpp
	./source/session/ZfsSession.h
	./source/session/Session.h
	./source/session/SessionLocalFileStore.h
	./source/session/SessionLocalFile.h
	./source/session/SessionStore.cpp
	./source/session/ZfsSession.cpp
	./source/session/SessionLocalFile.cpp
	./source/session/Session.cpp
	./source/session/SessionStore.h
	./source/session/SessionLocalFileStore.cpp
	./source/program/Program.h
	./source/program/Program.cpp
	./source/program/Main.cpp
	./source/app/App.h
	./source/app/App.cpp
	./source/app/config/Config.h
	./source/app/config/Config.cpp
	./source/nodes/StorageNodeOpStats.h
	./source/storage/ChunkDir.h
	./source/storage/SyncedStoragePaths.h
	./source/storage/QuotaBlockDevice.cpp
	./source/storage/ChunkLockStore.h
	./source/storage/ChunkStore.h
	./source/storage/StorageTargets.cpp
	./source/storage/ChunkStore.cpp
	./source/storage/QuotaBlockDevice.h
	./source/storage/StorageTargets.h
)

target_link_libraries(
	storage
	beegfs-common
	dl
	pthread
	blkid
)

add_executable(
	beegfs-storage
	source/program/Main.cpp
)

target_link_libraries(
	beegfs-storage
	storage
)

if(NOT BEEGFS_SKIP_TESTS)
	add_executable(
		test-storage
		./tests/TestConfig.h
		./tests/TestConfig.cpp
	)

	target_link_libraries(
		test-storage
		storage
		gtest_main
	)

	# required for a test
	file(
		COPY ${CMAKE_CURRENT_SOURCE_DIR}/build/dist/etc/beegfs-storage.conf
		DESTINATION dist/etc/
	)

	add_test(
		NAME test-storage
		COMMAND test-storage --compiler
	)
endif()

install(
	TARGETS beegfs-storage
	DESTINATION "usr/sbin"
	COMPONENT "storage"
)

install(
	FILES "build/dist/usr/lib/systemd/system/beegfs-storage.service" "build/dist/usr/lib/systemd/system/beegfs-storage@.service"
	DESTINATION "${CMAKE_INSTALL_LIBDIR}/systemd/system"
	COMPONENT "storage"
)

install(
	PROGRAMS "build/dist/sbin/beegfs-setup-storage"
	DESTINATION "usr/sbin"
	COMPONENT "storage"
)

install(
	FILES "build/dist/etc/beegfs-storage.conf"
	DESTINATION "etc/beegfs"
	COMPONENT "storage"
)

install(
	PROGRAMS "build/beegfs-storage.sh"
	RENAME "beegfs-storage"
	DESTINATION "opt/beegfs/sbin"
	COMPONENT "storage"
)

=== client_devel/build/Makefile ===
BEEGFS_COMMON_PATH ?= ../../common/

ifneq ($(BEEGFS_VERSION),)
BEEGFS_EXTRA_FLAGS += 'BEEGFS_VERSION="$(BEEGFS_VERSION)"'
endif

ifneq ($(BEEGFS_DEBUG),)
BEEGFS_EXTRA_FLAGS += 'BEEGFS_DEBUG=$(BEEGFS_DEBUG)'
endif


all: 

clean: 

help:
	@echo 'Optional Arguments:'
	@echo '   BEEGFS_DEBUG=1:'
	@echo '	     Enables debug information and symbols.'
	@echo '   CXX=<compiler>:'
	@echo '      Specifies a c++ compiler.'
	@echo '   BEEGFS_COMMON_PATH=<path>:'
	@echo '      Path to the common directory.'
	@echo
	@echo 'Targets:'
	@echo '   all (default)     - build only'
	@echo '   help              - print this help message'


# Include dependency files
ifneq ($(DEPENDENCY_FILES),)
include $(DEPENDENCY_FILES)
endif

=== client_module/build/Makefile ===

# This is the BeeGFS client makefile.
# It creates the client kernel module (beegfs.ko).
#
# Use "make help" to find out about configuration options.
#
# Note: This is the Makefile for internal use, there is a separate Release.mk
# file for release packages (to handle the closed source tree properly).

TARGET ?= beegfs

export TARGET
export OFED_INCLUDE_PATH
export BEEGFS_NO_RDMA

BEEGFS_DKMS_BUILD=0
ifdef KERNELRELEASE
BEEGFS_DKMS_BUILD=1
endif

ifeq ($(BEEGFS_DKMS_BUILD),1)
-include /etc/beegfs/beegfs-client-build.mk
endif
-include Version.mk

ifeq ($(obj),)
BEEGFS_BUILDDIR := $(shell pwd)
else
BEEGFS_BUILDDIR := $(obj)
endif

ifeq ($(KRELEASE),)
KRELEASE := $(shell uname -r)
endif

ifneq ($(BEEGFS_NO_RDMA),)
BEEGFS_CFLAGS += -DBEEGFS_NO_RDMA
else

$(info $$OFED_INCLUDE_PATH = [${OFED_INCLUDE_PATH}])

ifneq ($(OFED_INCLUDE_PATH),)
BEEGFS_CFLAGS += -I$(OFED_INCLUDE_PATH)
export KBUILD_EXTRA_SYMBOLS += $(OFED_INCLUDE_PATH)/../Module.symvers
endif
endif

# The following section deals with the auto-detection of the kernel
# build directory (KDIR)

# Guess KDIR based on running kernel.
# - "/usr/src/linux-headers-*" for Ubuntu
# - "/usr/src/kernels/*" for RHEL
# - "/lib/modules/*/build" for Debian, SLES
ifeq ($(KDIR),)
override KDIR = \
	/lib/modules/$(KRELEASE)/build \
	/lib/modules/default/build \
	/usr/src/linux-headers-$(KRELEASE) \
	/usr/src/linux-headers-default \
	/usr/src/kernels/$(KRELEASE) \
	/usr/src/kernels/default
endif

# Prune the KDIR list down to paths that exist and have an
# /include/linux/version.h file
# Note: linux-3.7 moved version.h to generated/uapi/linux/version.h
test_dir = $(shell [ -e $(dir)/include/linux/version.h -o \
	-e $(dir)/include/generated/uapi/linux/version.h ] && echo $(dir) )
KDIR_PRUNED := $(foreach dir, $(KDIR), $(test_dir) )

# We use the first valid entry of the pruned KDIR list
KDIR_PRUNED_HEAD := $(firstword $(KDIR_PRUNED) )


# The following section deals with the auto-detection of the kernel
# source path (KSRCDIR) which is required e.g. for KERNEL_FEATURE_DETECTION.

# Guess KSRCDIR based on KDIR
# (This is usually KDIR or KDIR/../source, so you can specify multiple
# directories here as a space-separated list)
ifeq ($(KSRCDIR),)

# Note: "KSRCDIR += $(KDIR)/../source" is not working here
# because of the symlink ".../build"), so we do it with substring
# replacement

KSRCDIR := $(subst /build,/source, $(KDIR_PRUNED_HEAD) )
KSRCDIR += $(KDIR)
endif

# Prune the KSRCDIR list down to paths that exist and contain an
# include/linux/fs.h file
test_dir = $(shell [ -e $(dir)/include/linux/fs.h ] && echo $(dir) )
KSRCDIR_PRUNED := $(foreach dir, $(KSRCDIR), $(test_dir) )

# We use the first valid entry of the pruned KSRCDIR list
KSRCDIR_PRUNED_HEAD := $(firstword $(KSRCDIR_PRUNED) )

ifeq ($(BEEGFS_NO_RDMA),)
# OFED
ifneq ($(OFED_INCLUDE_PATH),)

BEEGFS_CFLAGS += -I$(OFED_INCLUDE_PATH)

module: $(OFED_INCLUDE_PATH)/rdma/rdma_cm.h
$(OFED_INCLUDE_PATH)/rdma/rdma_cm.h:
	$(error OFED_INCLUDE_PATH not valid: $(OFED_INCLUDE_PATH))
endif
endif

# Include kernel feature auto-detectors
include KernelFeatureDetection.mk

KMOD_INST_DIR ?= $(DESTDIR)/lib/modules/$(KRELEASE)/updates/fs/beegfs

# Prepare CFLAGS:
# (Note: "-Wsign-compare" included in "-Wextra", but must be explicit here,
# because kernel Makefile adds "-Wno-sign-compare" by default. But we can't
# make it permanent here, because it generates a lot of warnings from kernel
# includes.)
BEEGFS_CFLAGS  :=  $(BUILD_ARCH) $(KERNEL_FEATURE_DETECTION) \
	-I$(BEEGFS_BUILDDIR)/../source \
	-I$(BEEGFS_BUILDDIR)/../include \
	-Wextra -Wno-sign-compare -Wno-empty-body -Wno-unused-parameter -Wno-missing-field-initializers \
	-DBEEGFS_MODULE_NAME_STR='\"$(TARGET)\"'

# Update 2022-12: BeeGFS module source code had already switched to -std=gnu99,
# but now the kernel has caught up with us - kernel moved from gnu89 to
# gnu11.
# So we're switching from gnu99 to gnu11, to not break the build with the newer
# kernels. We still need to specify this flag because that would break the
# client module build with older kernels, where gnu89 is the default.
BEEGFS_CFLAGS += -std=gnu11

ifeq ($(shell echo | gcc -Wtype-limits -E - >/dev/null 2>&1 && echo 1),1)
   BEEGFS_CFLAGS += -Wno-type-limits
endif

# -O0 would be better, but is not allowed by kernel includes (will not work)
BEEGFS_CFLAGS_DEBUG := -O1 -ggdb3 -rdynamic -fno-inline -DBEEGFS_DEBUG \
	-DLOG_DEBUG_MESSAGES -DDEBUG_REFCOUNT -DBEEGFS_LOG_CONN_ERRORS
BEEGFS_CFLAGS_RELEASE := -Wuninitialized

ifeq ($(BEEGFS_DEBUG),)
BEEGFS_CFLAGS += $(BEEGFS_CFLAGS_RELEASE)
else
BEEGFS_CFLAGS += $(BEEGFS_CFLAGS_DEBUG)
endif

ifeq ($(BEEGFS_NO_RDMA),)
# NVFS
ifneq ($(NVFS_INCLUDE_PATH),)
$(NVFS_INCLUDE_PATH)/nvfs-dma.h:
	$(error NVFS_INCLUDE_PATH missing nvfs-dma.h: $(NVFS_INCLUDE_PATH))
$(NVFS_INCLUDE_PATH)/config-host.h:
	$(error NVFS_INCLUDE_PATH missing config-host.h: $(NVFS_INCLUDE_PATH))
$(NVIDIA_INCLUDE_PATH)/nv-p2p.h:
	$(error NVIDIA_INCLUDE_PATH missing nv-p2p.h: $(NVIDIA_INCLUDE_PATH))
module: $(NVFS_INCLUDE_PATH)/nvfs-dma.h  $(NVFS_INCLUDE_PATH)/config-host.h \
	$(NVIDIA_INCLUDE_PATH)/nv-p2p.h

BEEGFS_CFLAGS += -DBEEGFS_NVFS
BEEGFS_CFLAGS += -I$(NVFS_INCLUDE_PATH)  -I$(NVIDIA_INCLUDE_PATH)
endif

endif

# if path to strip command was not given, use default
# (alternative strip is important when cross-compiling)
ifeq ($(STRIP),)
STRIP=strip
endif

BEEGFS_CFLAGS += '-DBEEGFS_VERSION=\"$(BEEGFS_VERSION)\"'

# Prepare RELEASE_PATH extension
ifneq ($(RELEASE_PATH),)
RELEASE_PATH_CLIENT := $(RELEASE_PATH)/client_module_$(shell echo '$(BEEGFS_VERSION)' | cut -d. -f1)
endif


all: module
	@ /bin/true

module: $(TARGET_ALL_DEPS)
ifeq ($(KDIR_PRUNED_HEAD),)
	$(error Linux kernel build directory not found. Please check if\
	the kernel module development packages are installed for the current kernel\
	version. (RHEL: kernel-devel; SLES: kernel-default-devel; Debian: linux-headers))
endif

ifeq ($(KSRCDIR_PRUNED_HEAD),)
	$(error Linux kernel source directory not found. Please check if\
	the kernel module development packages are installed for the current kernel\
	version. (RHEL: kernel-devel; SLES: kernel-default-devel; Debian: linux-headers))
endif

	@echo "Building beegfs client module"
	$(MAKE) -C $(KDIR_PRUNED_HEAD) "M=$(BEEGFS_BUILDDIR)/../source" \
	"EXTRA_CFLAGS=$(BEEGFS_CFLAGS) $(EXTRA_CFLAGS)"  modules

	@cp ../source/$(TARGET).ko .
	@ cp ${TARGET}.ko ${TARGET}-unstripped.ko
	@ ${STRIP} --strip-debug ${TARGET}.ko;

coccicheck:
	$(MAKE) -C $(KDIR_PRUNED_HEAD) "M=$(BEEGFS_BUILDDIR)"  coccicheck MODE=report \
		M=$(BEEGFS_BUILDDIR)/../source KBUILD_EXTMOD="$(BEEGFS_BUILDDIR)/../source"


include AutoRebuild.mk # adds auto_rebuild targets

prepare_release:
ifeq ($(RELEASE_PATH),)
	$(error RELEASE_PATH not defined)
endif

	@ echo "Creating release directory:" $(RELEASE_PATH_CLIENT)
	mkdir --parents $(RELEASE_PATH_CLIENT)/build \
		$(RELEASE_PATH_CLIENT)/source \
		$(RELEASE_PATH_CLIENT)/include

	@ echo "Storing beegfs version:" $(BEEGFS_VERSION)
	echo "BEEGFS_VERSION =" $(BEEGFS_VERSION) > $(RELEASE_PATH_CLIENT)/build/Version.mk

	@ echo "Copying beegfs client release files to" $(RELEASE_PATH_CLIENT) "..."
	cp Makefile $(RELEASE_PATH_CLIENT)/build/Makefile
	cp KernelFeatureDetection.mk $(RELEASE_PATH_CLIENT)/build/
	cp AutoRebuild.mk $(RELEASE_PATH_CLIENT)/build/
	cp feature-detect.sh $(RELEASE_PATH_CLIENT)/build/
	cp ../source/Makefile $(RELEASE_PATH_CLIENT)/source/

	find ../source -mount -name '*.h' -type f | \
		xargs -I ’{}’ cp --parents ’{}’ $(RELEASE_PATH_CLIENT)/build
	find ../source -mount -name '*.c' -type f | \
		xargs -I ’{}’ cp --parents ’{}’ $(RELEASE_PATH_CLIENT)/build
	find ../include -mount -name '*.h' -type f | \
		xargs -I ’{}’ cp --parents ’{}’ $(RELEASE_PATH_CLIENT)/build

# When used for development where the full BeeGFS source is available, this install target handles
# ensuring the mount.beegfs script is installed. If the mount.script is not present in the source,
# for example if the install target was invoked via the BeeGFS client service and AutoRebuild.mk, it
# just checks the script already exists at /sbin/mount.beegfs since the script should have been
# installed by the package manager. If it does not exist an error is returned as this is likely a
# bug elsewhere related to installing the script, or somebody is trying to use this Makefile in an
# unsupported/unexpected manner and further investigation is required.
install:
	install -D -m 644 $(TARGET).ko $(KMOD_INST_DIR)/$(TARGET).ko
	@if [ -f dist/sbin/mount.beegfs ]; then \
		install -D -m 755 dist/sbin/mount.beegfs /sbin/mount.beegfs; \
		echo "Info: Installed mount script at /sbin/mount.beegfs."; \
	elif [ ! -f /sbin/mount.beegfs ]; then \
		echo "Error: mount.beegfs does not already exist at /sbin/mount.beegfs (this is likely a bug elsewhere)."; \
		exit 1; \
	fi
	depmod -a $(KRELEASE)

clean:
	rm -f *~ .${TARGET}??*
	rm -f .*.cmd *.mod.c *.mod.o *.o *.ko *.ko.unsigned
	rm -f ../source/Module*.symvers ../source/modules.order ../source/Module.markers
	rm -f Module*.symvers modules.order Module.markers
	rm -f $(AUTO_REBUILD_KVER_FILE)
	rm -rf .tmp_versions/
	find ../source/ -mount -name '*.o' -type f -delete
	find ../source/ -mount -name '.*.o.cmd' -type f -delete
	find ../source/ -mount -name '.*.o.d' -type f -delete
	find ../source/ -mount -name '*.gcno' -type f -delete

help:
	@echo "This makefile creates the kernel module: $(TARGET) (beegfs-client)"
	@echo ' '
	@echo 'client Arguments (required):'
	@echo '  RELEASE_PATH=<path> (Target: prepare_release)'
	@echo '    The path to the client release directory.'
	@echo ' '
	@echo 'client Arguments (optional):'
	@echo '   KRELEASE=<release>: Kernel release'
	@echo '     (The output of "uname -r" will be used if undefined.'
	@echo '      This option is useful when building for a kernel different'
	@echo '      from the one currently running (e.g. in a chroot).)'
	@echo '   KDIR=<path>: Kernel build directory.'
	@echo '     (Will be guessed based on running kernel or KRELEASE if undefined.)'
	@echo '   KSRCDIR=<path>: Kernel source directory containing the kernel include '
	@echo '     directory. (Will be guessed based on KDIR if undefined.)'
	@echo '   BEEGFS_DEBUG=1:'
	@echo '     Enables file sytem debug log messages etc.'
	@echo '   TARGET=<MODULE_NAME>'
	@echo '     Set a different module and file system name.'
	@echo ' '
	@echo 'Infiniband (RDMA) arguments (optional):'
	@echo '   OFED_INCLUDE_PATH=<path>:'
	@echo '     Path to OpenFabrics Enterpise Distribution kernel include directory, e.g.'
	@echo '     "/usr/src/openib/include". (If not defined, the standard kernel headers'
	@echo '      will be used.)'
	@echo ''
	@echo 'NVIDIA GPUDirect Storage (GDS) arguments (optional):'
	@echo '  NVFS_INCLUDE_PATH=<path>:'
	@echo '    Path to directory that contains nvfs-dma.h. If not defined, GDS support is'
	@echo '    disabled.'
	@echo '  NVIDIA_INCLUDE_PATH=<path>:'
	@echo '    Path to NVIDIA driver source. Required when NVFS_INCLUDE_PATH is specifed.'
	@echo ''
	@echo 'Targets:'
	@echo '   all (default)     - build only'
	@echo '   install           - install the kernel modules'
	@echo '   clean             - delete previously compiled files'
	@echo '   prepare_release   - build and copy files into the RELEASE_PATH directory'

=== client_module/source/Makefile ===
# NOTE(jstimpfle, 2022-04): I changed the interface of the feature-detect.sh
# script to take some arguments explicitly from the command-line, as opposed to
# implicitly from the environment.
#
# The reason is that we hit a case where there was a string literal in
# KBUILD_CFLAGS (generated in Linux kernel Makefiles), and since this variable
# is normally used as part of shell commands contained in Makefiles this
# string literal is wrapped in a pair of single quotes,
# like this '"string literal"'.

BEEGFS_FEATURE_DETECTION := $(shell $(dir $(lastword $(MAKEFILE_LIST)))/../build/feature-detect.sh $(KBUILD_CFLAGS) $(KBUILD_CPPFLAGS))

ifneq ($(lastword $(BEEGFS_FEATURE_DETECTION)),--~~success~~--)
   $(error feature detection reported an error)
else
   BEEGFS_FEATURE_DETECTION := $(filter-out --~~success~~--,$(BEEGFS_FEATURE_DETECTION))
   $(info feature detection gives: $(BEEGFS_FEATURE_DETECTION))
endif

# ccflags-y was introduced in 2.6.24, earlier kernels use EXTRA_CFLAGS for the same purpose
ifeq ($(origin ccflags-y),file)
ccflags-y += $(BEEGFS_FEATURE_DETECTION)
else
# the client makefile sets this already
override EXTRA_CFLAGS += $(BEEGFS_FEATURE_DETECTION)
endif

kernel-version = $(shell printf "%02d%02d" $(VERSION) $(PATCHLEVEL))
kernel-if-version-or-later = $(shell [ $(kernel-version) -ge $(1) ] && echo $(2))

obj-m	+= ${TARGET}.o

SOURCES := \
   fault-inject/fault-inject.c \
   os/iov_iter.c \
   os/atomic64.c \
   os/OsCompat.c \
   os/OsDeps.c \
   net/message/NetMessageFactory.c \
   net/filesystem/FhgfsOpsCommKit.c \
   net/filesystem/FhgfsOpsRemoting.c \
   net/filesystem/FhgfsOpsCommKitVec.c \
   common/system/System.c \
   common/net/sock/Socket.c \
   common/net/sock/NicAddress.c \
   common/net/sock/NetworkInterfaceCard.c \
   common/net/sock/NicAddressList.c \
   common/net/sock/RDMASocket.c \
   common/net/sock/ibv/IBVSocket.c \
   common/net/sock/ibv/IBVBuffer.c \
   common/net/sock/ibv/No_IBVSocket.c \
   common/net/sock/StandardSocket.c \
   common/net/message/control/PeerInfoMsg.c \
   common/net/message/SimpleIntMsg.c \
   common/net/message/NetMessage.c \
   common/net/message/session/locking/FLockEntryMsg.c \
   common/net/message/session/locking/FLockAppendMsg.c \
   common/net/message/session/locking/LockGrantedMsgEx.c \
   common/net/message/session/locking/FLockRangeMsg.c \
   common/net/message/session/GetFileVersionRespMsg.c \
   common/net/message/session/rw/ReadLocalFileV2Msg.c \
   common/net/message/session/rw/ReadLocalFileRDMAMsg.c \
   common/net/message/session/rw/WriteLocalFileMsg.c \
   common/net/message/session/rw/WriteLocalFileRDMAMsg.c \
   common/net/message/session/FSyncLocalFileMsg.c \
   common/net/message/session/GetFileVersionMsg.c \
   common/net/message/session/opening/OpenFileMsg.c \
   common/net/message/session/opening/OpenFileRespMsg.c \
   common/net/message/session/opening/CloseFileMsg.c \
   common/net/message/session/BumpFileVersion.c \
   common/net/message/SimpleInt64Msg.c \
   common/net/message/SimpleUInt16Msg.c \
   common/net/message/SimpleStringMsg.c \
   common/net/message/SimpleIntStringMsg.c \
   common/net/message/nodes/RegisterNodeMsg.c \
   common/net/message/nodes/RegisterNodeRespMsg.c \
   common/net/message/nodes/HeartbeatRequestMsgEx.c \
   common/net/message/nodes/MapTargetsMsgEx.c \
   common/net/message/nodes/GetTargetMappingsRespMsg.c \
   common/net/message/nodes/HeartbeatMsgEx.c \
   common/net/message/nodes/RemoveNodeMsgEx.c \
   common/net/message/nodes/GetStatesAndBuddyGroupsMsg.c \
   common/net/message/nodes/GetStatesAndBuddyGroupsRespMsg.c \
   common/net/message/nodes/RefreshTargetStatesMsgEx.c \
   common/net/message/nodes/GetNodesRespMsg.c \
   common/net/message/nodes/SetMirrorBuddyGroupMsgEx.c \
   common/net/message/SimpleMsg.c \
   common/net/message/storage/moving/RenameMsg.c \
   common/net/message/storage/StatStoragePathRespMsg.c \
   common/net/message/storage/creating/HardlinkMsg.c \
   common/net/message/storage/creating/MkFileMsg.c \
   common/net/message/storage/creating/MkDirMsg.c \
   common/net/message/storage/creating/UnlinkFileMsg.c \
   common/net/message/storage/creating/MkDirRespMsg.c \
   common/net/message/storage/creating/RmDirMsg.c \
   common/net/message/storage/creating/MkFileRespMsg.c \
   common/net/message/storage/attribs/StatRespMsg.c \
   common/net/message/storage/attribs/ListXAttrRespMsg.c \
   common/net/message/storage/attribs/SetAttrMsg.c \
   common/net/message/storage/attribs/ListXAttrMsg.c \
   common/net/message/storage/attribs/RefreshEntryInfoMsg.c \
   common/net/message/storage/attribs/StatMsg.c \
   common/net/message/storage/attribs/GetXAttrRespMsg.c \
   common/net/message/storage/attribs/GetXAttrMsg.c \
   common/net/message/storage/attribs/RemoveXAttrMsg.c \
   common/net/message/storage/attribs/SetXAttrMsg.c \
   common/net/message/storage/lookup/LookupIntentRespMsg.c \
   common/net/message/storage/lookup/LookupIntentMsg.c \
   common/net/message/storage/TruncFileMsg.c \
   common/net/message/storage/listing/ListDirFromOffsetRespMsg.c \
   common/net/message/storage/listing/ListDirFromOffsetMsg.c \
   common/threading/Thread.c \
   common/toolkit/Serialization.c \
   common/toolkit/MessagingTk.c \
   common/toolkit/HashTk.c \
   common/toolkit/ackstore/WaitAckMap.c \
   common/toolkit/ackstore/AcknowledgmentStore.c \
   common/toolkit/ackstore/AckStoreMap.c \
   common/toolkit/Random.c \
   common/toolkit/tree/IntMap.c \
   common/toolkit/tree/StrCpyMap.c \
   common/toolkit/tree/PointerRBTree.c \
   common/toolkit/NodesTk.c \
   common/toolkit/SocketTk.c \
   common/toolkit/MetadataTk.c \
   common/toolkit/StringTk.c \
   common/toolkit/ListTk.c \
   common/Types.c \
   common/nodes/Node.c \
   common/nodes/TargetMapper.c \
   common/nodes/MirrorBuddyGroup.c \
   common/nodes/NumNodeID.c \
   common/nodes/TargetStateStore.c \
   common/nodes/NodeTree.c \
   common/nodes/MirrorBuddyGroupMapper.c \
   common/nodes/NodeConnPool.c \
   common/storage/StorageErrors.c \
   common/storage/StatData.c \
   common/storage/striping/BuddyMirrorPattern.c \
   common/storage/striping/SimplePattern.c \
   common/storage/striping/StripePattern.c \
   common/storage/striping/Raid10Pattern.c \
   common/storage/striping/Raid0Pattern.c \
   common/storage/PathInfo.c \
   common/storage/RdmaInfo.c \
   common/storage/Nvfs.c \
   common/storage/EntryInfo.c \
   common/storage/StoragePoolId.c \
   common/storage/FileEvent.c \
   program/Main.c \
   toolkit/FhgfsChunkPageVec.c \
   toolkit/StatFsCache.c \
   toolkit/NoAllocBufferStore.c \
   toolkit/InodeRefStore.c \
   toolkit/BitStore.c \
   components/DatagramListener.c \
   components/InternodeSyncer.c \
   components/Flusher.c \
   components/worker/RWPagesWork.c \
   components/AckManager.c \
   nodes/NodeStoreEx.c \
   filesystem/ProcFs.c \
   filesystem/FhgfsOpsPages.c \
   filesystem/FhgfsOpsFile.c \
   filesystem/FhgfsOpsInode.c \
   filesystem/FhgfsOpsFileNative.c \
   filesystem/FhgfsInode.c \
   filesystem/helper/IoctlHelper.c \
   filesystem/FsFileInfo.c \
   filesystem/ProcFsHelper.c \
   filesystem/FhgfsOpsSuper.c \
   filesystem/FhgfsOps_versions.c \
   filesystem/FhgfsXAttrHandlers.c \
   filesystem/FhgfsOpsDir.c \
   filesystem/FhgfsOpsIoctl.c \
   filesystem/FhgfsOpsExport.c \
   filesystem/FhgfsOpsHelper.c \
   app/App.c \
   app/log/Logger.c \
   app/config/MountConfig.c \
   app/config/Config.c

${TARGET}-y	:= $(patsubst %.c,%.o,$(SOURCES))

ifdef BEEGFS_NO_RDMA
ccflags-y += -DBEEGFS_NO_RDMA
endif

ifneq ($(OFED_INCLUDE_PATH),)

# RHEL/CentOS 8 + MLNX 4.7 requires extra flags (bug?)
ccflags-y += $(call kernel-if-version-or-later, 0418, -DHAVE_BITS_H)

NOSTDINC_FLAGS+=-I$(OFED_INCLUDE_PATH) -I$(OFED_INCLUDE_PATH)/uapi
ifeq ($(shell [ -f $(OFED_INCLUDE_PATH)/linux/compat-2.6.h ] && echo 1),1)
ccflags-y += -include $(OFED_INCLUDE_PATH)/linux/compat-2.6.h
endif

endif

=== common/build/Makefile ===
include ../../build/Makefile


$(call build-static-library,\
   beegfs-common,\
   $(shell find ../source -iname '*.cpp'),\
   dl nl3-route,\
   ../source)

$(call build-shared-library,\
   beegfs_ib,\
   $(shell find ../ib_lib -iname '*.cpp'),\
   rdma,\
   ../source ../ib_lib)


$(call build-test,\
   test-runner,\
   $(shell find ../tests -name '*.cpp'),\
   common,\
   ../tests)

=== event_listener/build/Makefile ===
SHELL = /bin/bash

EXE = beegfs-event-listener

CXXFLAGS = -std=c++17 -I ../include
LDFLAGS =

SOURCES = $(shell find ../source -name '*.cpp')
OBJECTS = $(SOURCES:.cpp=.o)
DEPENDENCY_FILES = $(shell find ../source -name '*.d')
CLEANUP_OBJECTS = $(shell find ../source -name '*.o') $(DEPENDENCY_FILES)

all: $(SOURCES) $(EXE)

$(EXE): $(OBJECTS)
	$(CXX) -o $(EXE) $(OBJECTS) $(LDFLAGS)

.cpp.o:
	$(CXX) $(CXXFLAGS) -c $(@:.o=.cpp) -E -MMD -MF$(@:.o=.d) -MT$(@) -o/dev/null
	$(CXX) $(CXXFLAGS) -o$(@) -c $(@:.o=.cpp)

clean:
	rm -rf $(CLEANUP_OBJECTS) $(DEPENDENCY_FILES) $(EXE)


# Include dependency files
ifneq ($(DEPENDENCY_FILES),)
include $(DEPENDENCY_FILES)
endif

=== debian/changelog ===
beegfs (8.1.0~20250810022543.7+bookworm) unstable; urgency=medium

  [ root ]
  * New Release

  [ jenkins-debian-glue Autobuilder ]
  * SNAPSHOT autobuild for unreleased 8.1.0 via jenkins-debian-glue.

 -- jenkins-debian-glue Autobuilder <jenkins@debdev.disconnected-by-peer.at>  Sun, 10 Aug 2025 04:25:43 +0200

beegfs (0-dev) unstable; urgency=low

  * please see http://www.beegfs.com for changelog

 -- BeeGFS Maintainers <packages@beegfs.com>  Thu, 01 Jan 1970 01:00:00 +0100

=== debian/control ===
Source: beegfs
Section: misc
Priority: optional
Maintainer: BeeGFS Maintainers <packages@beegfs.com>
Build-Depends: debhelper (>= 12.0.0), lsb-release, build-essential, autoconf, automake, devscripts, librdmacm-dev, libibverbs-dev, kmod,
               dkms (<= 3.0.0) | dh-dkms (>=3.0.0), pkg-config, zlib1g-dev, libnl-3-dev, libnl-route-3-dev, libtool, libattr1-dev,
               xfslibs-dev, default-jdk, libssl-dev, libcurl4-openssl-dev, libblkid-dev, uuid-dev, libnl-3-200, libnl-genl-3-200,
               libnl-route-3-200
Standards-Version: 4.1.4.1



Package: libbeegfs-ib
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: BeeGFS InfiniBand support
 This package contains support libraries for InfiniBand.



Package: beegfs-meta
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libbeegfs-ib (= ${binary:Version})
Description: BeeGFS metadata server daemon
 The package contains the BeeGFS metadata daemon.



Package: beegfs-storage
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libbeegfs-ib (= ${binary:Version})
Description: BeeGFS storage server daemon
 This package contains the BeeGFS storage server binaries.



Package: beegfs-mon
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libbeegfs-ib (= ${binary:Version})
Description: BeeGFS mon daemon
 The package contains the BeeGFS mon daemon.



Package: beegfs-mon-grafana
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: BeeGFS mon dashboards for Grafana
 This package contains the BeeGFS mon dashboards to display monitoring data in Grafana.
 The default dashboard setup requires both Grafana, and InfluxDB.



Package: beegfs-utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libbeegfs-ib (= ${binary:Version})
Description: BeeGFS utils
 This package contains BeeGFS utilities.



Package: beegfs-utils-dev
Architecture: any
Depends: ${misc:Depends}
Description: BeeGFS utils devel files
 This package contains BeeGFS development files and examples.

Package: beeond
Architecture: all
Depends: ${misc:Depends},
  beegfs-utils (= ${binary:Version}), beegfs-mgmtd (= ${binary:Version}), beegfs-meta (= ${binary:Version}),
  beegfs-storage (= ${binary:Version}),
  beegfs-client (= ${binary:Version}) | beegfs-client-dkms (= ${binary:Version}),
  psmisc
Description: BeeOND
 This package contains BeeOND.



Package: beegfs-client
Architecture: all
Depends: ${misc:Depends}, build-essential
Conflicts: beegfs-client-dkms
Recommends: linux-headers-amd64
Description: BeeGFS client
 This package contains scripts, config and source files to build and
 start beegfs-client.

Package: beegfs-client-dkms
Architecture: all
Depends: ${misc:Depends}, dkms
Conflicts: beegfs-client
Recommends: linux-headers-amd64
Description: BeeGFS client (DKMS version)
 This package contains scripts, config and source files to build and
 start beegfs-client. It uses DKMS to build the kernel module.

Package: beegfs-client-compat
Architecture: all
Description: BeeGFS client compat module, allows one to run two different client versions.
 This package allows one to build and to run a compatibility client
 kernel module on a system that has a newer beegfs-client version
 installed.
Depends: ${misc:Depends}, build-essential

Package: beegfs-client-dev
Architecture: any
Depends: ${misc:Depends}
Description: BeeGFS client development files
 This package contains BeeGFS client development files.
